sbit soft_i2c_scl           at rb4_bit;
sbit soft_i2c_sda           at rb5_bit;    // i2c (DS1307)
sbit soft_i2c_scl_direction at trisb4_bit;
sbit soft_i2c_sda_direction at trisb5_bit;

sbit lcd_rs at rc2_bit;
sbit lcd_en at rc3_bit;
sbit lcd_d4 at ra6_bit;
sbit lcd_d5 at ra7_bit; // 
sbit lcd_d6 at rc5_bit;
sbit lcd_d7 at rc4_bit;

sbit lcd_rs_direction at trisc2_bit;
sbit lcd_en_direction at trisc3_bit;
sbit lcd_d4_direction at trisa6_bit; // 
sbit lcd_d5_direction at trisa7_bit;
sbit lcd_d6_direction at trisc5_bit;
sbit lcd_d7_direction at trisc4_bit;

//ak1[6]- 1  1
//ak1[5]- 2  1
//ak1[4]-  1
//ak1[3]-  1
//ak1[2]-  1
//ak1[1]-  1

//ak2[1]- 1  2
//ak2[2]- 2  2
//ak2[3]-  2
//ak2[4]-  2
//ak2[5]-  2
//ak2[6]-  2
//ak1[0],ak1[7],ak2[0],ak2[7]      
char tx1[4], tx2[16]; //     
unsigned short ak1[8], ak2[8], sst, mmt, hht, chd, msd, gdd, mnu, i;
//ak1[8]-     (1 )
//ak2[8]-     (2 )
//sst-  (  DS1307)
//mmt-  (  DS1307)
//hht-  (  DS1307)
//chd-  (  DS1307)
//msd-  (  DS1307)
//gdd-  (  DS1307)
//mnu- 
//i-   
unsigned short pd1, pd2, inf, tc[3], td[3], dt1[3][8], s0, s1;
//pd1-  / ( eeprom 0x00)
//pd2-    ( eeprom 0x01)
//inf-      ( eeprom 0x02)
//tc[3]-      
//td[3]-      
//dt1[3][8]-  1..3 ( eeprom 0x03..0x1a)
//s0-   
//s1-   
unsigned short chv[2], msv[2], gdv[2], chf[2], msf[2], gdf[2], hh[16], mm[16], ts[2], tsv[2];
//chv[2]-     1,2 ( eeprom 0x1b,0x1c)
//msv[2]-     1,2 ( eeprom 0x1d,0x1e)
//gdv[2]-     1,2 ( eeprom 0x1f,0x20)
//chf[2]-     1,2 ( eeprom 0x21,0x22)
//msf[2]-     1,2 ( eeprom 0x23,0x24)
//gdf[2]-     1,2 ( eeprom 0x25,0x26)
//hh[16]- /    1,2 ( eeprom 0x27..0x36)
//mm[16]- /    1,2 ( eeprom 0x37..0x46)
//ts[2]-    1,2 ( eeprom 0x47,0x48)
//tsv[2]-  1,2 / ( eeprom 0x49,0x4a)
unsigned short fp[2], flv[2], fls[2], flm[2], vzr[2], vzp[2], vzv[2], kr[16], pds, nms;
//fp[2]-      1,2 ( eeprom 0x4b,0x4c)
//flv[2]-   1,2 / ( eeprom 0x4d,0x4e)
//fls[2]-     1,2
//flm[2]-     1,2
//vzr[2]-     1,2 ( eeprom 0x4f,0x50)
//vzp[2]-     1,2 ( eeprom 0x51,0x52)
//vzv[2]- /   1,2 ( eeprom 0x53,0x54)
//kr[16]-      1,2 ( eeprom 0x55..0x64)
//pds-     
//nms-   
unsigned short krv[4], vgr, ngr, grv, ot, sp, irv, irm, sbk[4], sb1[4], sb2[4];
//vgr-()  ()  ( eeprom 0x65)
//ngr-()  ()  ( eeprom 0x66)
//grv-()  / ( eeprom 0x67)
//ot-   ( eeprom 0x68)
//sp-   ( eeprom 0x69)
//irv-  / ( eeprom 0x6a)
//irm-     ( eeprom 0x6b)
//sbk[4]-          
//sb1[4]-  sb1 ( ) ( eeprom 0x6c..0x6f)
//sb2[4]-  sb2 ( ) ( eeprom 0x70..0x73)
unsigned short sb3[4], sb4[4], sb5[4], t11[4], t12[4], t21[4], t22[4], fl1[4], fl2[4], vz1[4];
//sb3[4]-  sb3 ( ) ( eeprom 0x74..0x77)
//sb4[4]-  sb4 ( ) ( eeprom 0x78..0x7b)
//sb5[4]-  sb5 ( ) ( eeprom 0x7c..0x7f)
//t11[4]-  ( )     1 ( 1) ( eeprom 0x80..0x83)
//t12[4]-  ( )     1 ( 2) ( eeprom 0x84..0x87)
//t21[4]-  ( )     2 ( 1) ( eeprom 0x88..0x8b)
//t22[4]-  ( )     2 ( 2) ( eeprom 0x8c..0x8f)
//fl1[4]-  ( )     ( 1) ( eeprom 0x90..0x93)
//fl2[4]-  ( )     ( 2) ( eeprom 0x94..0x97)
//vz1[4]-  ( )     ( 1) ( eeprom 0x98..0x9b)
unsigned short vz2[4], kr1[4], kr2[4], dt4[8], mmv1, mmv2, ssk1, ssk2, i1, i2;
//vz2[4]-  ( )     ( 2) ( eeprom 0x9c..0x9f)
//kr1[4]-  ( )     ( 1) ( eeprom 0xa0..0xa3)
//kr2[4]-  ( )     ( 2) ( eeprom 0xa4..0xa7)
//dt4[8]-   
//mmv1-     1
//mmv2-     1
//ssk1-    1   
//ssk2-    2   
//i1,i2-     
unsigned short irk[8], irb[4], b11, j, ssp, nd[3];
//irk[8]-   ()
//irb[4]-      
//b11-    (  )
//j-
//ssp-  0,5 
//nd[3]-8      (      16)
unsigned t, z1, z2;
//t-   
//z1,z2-   (    1,2   )
bit kp1, kp2, kp3, kp4, kp5, bt1, bt2, bt3, bt4, bt5, pdv, f1, f2, v11, v12, v13, v21, v22, v23, k1, k2, ng;
bit in1, pog, kp6, kp7, tz3, ir0, ir1, ir2, pr;
//bt1- sb1 
//bt2- sb2 
//bt3- sb3 
//bt4- sb4 
//bt5- sb5 
//pdv- /
//f1,f2-     
//v11..v23-    / 
//k1,k2-   
//ng-    /   
//in1- 1           
//pog-   1   
//tz3-    3
//ir0,ir1,ir2-  
//pr-     

void interrupt() //  (   RB0)
{
if (irv==1) //  
{
pr=0; //          ( 0,1 )
if (ir0==1) //     (   )
{
if (irm==1 || irm==2)
{ //irm=1-  (  )  NEC, JVC, SAMSUNG ( ,   - 0,  ,   - 1)
  //irm=2-  (  )  Sony ( ,   - 0,  ,   - 1)
if (i1==0) tmr0=0; //     
option_reg.b6=~option_reg.b6; ///   / 
ir1=~ir1;
if (ir1==0)
{
s0=tmr0; tmr0=0; //  
}
if (ir1==1)
{
s1=tmr0; tmr0=0; //  
if (i1>3) //      (4 )
{
if (irm==1) {if (s1>(s0+s0/2)) irk[i2]=1; else irk[i2]=0; i2++;} //        1  0
if (irm==2) {if (s0>(s1+s1/2)) irk[i2]=1; else irk[i2]=0; i2++;} //        1  0
}
}
i1++;
if (i2>7) //     ( 4  )
{
irb[0]=(irk[1]<<1)+irk[0];   irb[1]=(irk[3]<<1)+irk[2];
irb[2]=(irk[5]<<1)+irk[4];   irb[3]=(irk[7]<<1)+irk[6];
irb[0]=(irb[1]<<2)+irb[0];   irb[2]=(irb[3]<<2)+irb[2];
irb[0]=(irb[2]<<4)+irb[0];   sbk[j]=irb[0]; //  
i2=0;
j++;
if (j>3)
{
option_reg=0x06; //    
ir0=0; //    
j=0; ir2=1; // ,       
}
}
}

if (irm==3) //  ( )  RC5
{
option_reg.b6=~option_reg.b6; ///   / 
if (i1==0) //  
{
tmr0=0; //     
i2=0; irk[i2]=~rb0_bit; i2++; //  
ir1=0; // ,     
}
if (i1>0) //  15 
{
if (i1==1) {s1=tmr0; s1=s1+s1/3;} //        
s0=tmr0; tmr0=0; //      
if (s0>s1) {irk[i2]=~rb0_bit; i2++; ir1=0;} //  ,      
if (s0<s1) //  ,        
{ //  ,          
if (ir1==0) ir1=1; else {irk[i2]=~rb0_bit; i2++; ir1=0;}
} //    ,      -     
}
i1++;
if (i2>7) //     ( 2  )
{
irb[0]=(irk[1]<<1)+irk[0];   irb[1]=(irk[3]<<1)+irk[2];
irb[2]=(irk[5]<<1)+irk[4];   irb[3]=(irk[7]<<1)+irk[6];
irb[0]=(irb[1]<<2)+irb[0];   irb[2]=(irb[3]<<2)+irb[2];
irb[0]=(irb[2]<<4)+irb[0];   sbk[j]=irb[0]; //  
i2=0;
j++;
if (j>1)
{
sbk[2]=0; sbk[3]=0;
option_reg=0x06; //    
ir0=0; //    
j=0; ir2=1; // ,       
}
}
}

if (mnu!=9 && mnu!=10 && ir2==1) //     " "  ""
{
if (sb1[0]==sbk[0] && sb1[1]==sbk[1] && sb1[2]==sbk[2] && sb1[3]==sbk[3]) {bt1=1; pdv=1;} // SB1 
if (sb2[0]==sbk[0] && sb2[1]==sbk[1] && sb2[2]==sbk[2] && sb2[3]==sbk[3]) {bt2=1; nms++; if (nms>b11) nms=1; pdv=1;} // SB2 
if (sb3[0]==sbk[0] && sb3[1]==sbk[1] && sb3[2]==sbk[2] && sb3[3]==sbk[3]) {bt3=1; nms--; if (nms<1) nms=b11; pdv=1;} // SB3 
if (sb4[0]==sbk[0] && sb4[1]==sbk[1] && sb4[2]==sbk[2] && sb4[3]==sbk[3]) {bt4=1; pdv=1;} // SB4 
if (sb5[0]==sbk[0] && sb5[1]==sbk[1] && sb5[2]==sbk[2] && sb5[3]==sbk[3]) {bt5=1; pdv=1;} // SB5 

if (t11[0]==sbk[0] && t11[1]==sbk[1] && t11[2]==sbk[2] && t11[3]==sbk[3]) {if (ak1[6]==1) ak1[6]=0; else ak1[6]=1; pdv=1;} //  1  1
if (t12[0]==sbk[0] && t12[1]==sbk[1] && t12[2]==sbk[2] && t12[3]==sbk[3]) {if (ak2[1]==1) ak2[1]=0; else ak2[1]=1; pdv=1;} //  1  2
if (t21[0]==sbk[0] && t21[1]==sbk[1] && t21[2]==sbk[2] && t21[3]==sbk[3]) {if (ak1[5]==1) ak1[5]=0; else ak1[5]=1; pdv=1;} //  2  1
if (t22[0]==sbk[0] && t22[1]==sbk[1] && t22[2]==sbk[2] && t22[3]==sbk[3]) {if (ak2[2]==1) ak2[2]=0; else ak2[2]=1; pdv=1;} //  2  2

if (fl1[0]==sbk[0] && fl1[1]==sbk[1] && fl1[2]==sbk[2] && fl1[3]==sbk[3]) {if (flv[0]==1) {if (ak1[4]==1) {ak1[4]=0; f1=1;} else {ak1[4]=1; f1=0;}} pdv=1;} //   1
if (fl2[0]==sbk[0] && fl2[1]==sbk[1] && fl2[2]==sbk[2] && fl2[3]==sbk[3]) {if (flv[1]==1) {if (ak2[3]==1) {ak2[3]=0; f2=1;} else {ak2[3]=1; f2=0;}} pdv=1;} //   2

if (vz1[0]==sbk[0] && vz1[1]==sbk[1] && vz1[2]==sbk[2] && vz1[3]==sbk[3]) {if (v11==1) {if (ak1[3]==1) ak1[3]=0; else ak1[3]=1; mmv1=0;} pdv=1;} //   1
if (vz2[0]==sbk[0] && vz2[1]==sbk[1] && vz2[2]==sbk[2] && vz2[3]==sbk[3]) {if (v21==1) {if (ak2[4]==1) ak2[4]=0; else ak2[4]=1; mmv2=0;} pdv=1;} //   2

if (kr1[0]==sbk[0] && kr1[1]==sbk[1] && kr1[2]==sbk[2] && kr1[3]==sbk[3]) {if (kr[3]==1  || kr[7]==1)  {if (ak1[2]==1) ak1[2]=0; else {ak1[2]=1; k1=1;}} pdv=1;} //   1
if (kr2[0]==sbk[0] && kr2[1]==sbk[1] && kr2[2]==sbk[2] && kr2[3]==sbk[3]) {if (kr[11]==1 || kr[15]==1) {if (ak2[5]==1) ak2[5]=0; else {ak2[5]=1; k2=1;}} pdv=1;} //   2
ir2=0;
}
}
}
intcon=0x10; //  
}


void znak() //      "","","",""
{
for (ak1[0]=64; ak1[0]<97; ak1[0]=ak1[0]+8)
{
tx2[7]=0;
if (ak1[0]==64) {tx2[0]=6;  tx2[1]=9; tx2[2]=9;  tx2[3]=6;  tx2[4]=0;  tx2[5]=0;  tx2[6]=0;}  //    ( 0x00)
if (ak1[0]==72) {tx2[0]=10; tx2[1]=4; tx2[2]=17; tx2[3]=19; tx2[4]=21; tx2[5]=25; tx2[6]=17;} // ""      ( 0x01)
if (ak1[0]==80) {tx2[0]=0;  tx2[1]=0; tx2[2]=30; tx2[3]=17; tx2[4]=30; tx2[5]=17; tx2[6]=30;} // ""      ( 0x02)
if (ak1[0]==88) {tx2[0]=0;  tx2[1]=0; tx2[2]=17; tx2[3]=18; tx2[4]=28; tx2[5]=18; tx2[6]=17;} // ""      ( 0x03)
if (ak1[0]==96) {tx2[0]=0;  tx2[1]=0; tx2[2]=16; tx2[3]=16; tx2[4]=30; tx2[5]=17; tx2[6]=30;} // ""      ( 0x04)
lcd_cmd(ak1[0]); for (i=0; i<8; i++) lcd_chr_cp(tx2[i]); // 
lcd_cmd(_lcd_return_home); //   
}
}

void but1(unsigned short b) // 
{
b11=b;
if (ra4_bit==1) kp1=1; 
if (kp1==1 && ra4_bit==0) {bt1=1; kp1=0; pdv=1;} ///   

if (rb7_bit==1) kp2=1;
if (kp2==1 && rb7_bit==0) {bt2=1; nms++; if (nms>b) nms=1; kp2=0; pdv=1;} //   

if (re3_bit==1) kp3=1;
if (kp3==1 && re3_bit==0) {bt3=1; nms--; if (nms<1) nms=b; kp3=0; pdv=1;} //   

if (rb6_bit==1) kp4=1;
if (kp4==1 && rb6_bit==0) {bt4=1; kp4=0; pdv=1; kp4=kp6;} //  1

if (rb3_bit==1) kp5=1;
if (kp5==1 && rb3_bit==0) {bt5=1; kp5=0; pdv=1; kp5=kp7;} //  1    
}

void stroka(unsigned short s) //    
{
for (i=1; i<17; i++) lcd_chr(s,i,tx2[i-1]);
}

void temp(unsigned short dtn) //  (dtn- )
{
ow_reset(&porta,0); //  1-Wire
ow_write(&porta,0,0x55); //     
for (i=0; i<8; i++) ow_write(&porta,0,dt1[dtn][i]); //  
ow_write(&porta,0,0x44); //    
delay_us(500);
ow_reset(&porta,0); //  1-Wire
ow_write(&porta,0,0x55); //     
for (i=0; i<8; i++) ow_write(&porta,0,dt1[dtn][i]); //  
ow_write(&porta,0,0xbe); //    
t=ow_read(&porta,0); //  
t=(ow_read(&porta,0)<<8)+t; //       
for (i=0; i<6; i++) nd[dtn]=ow_read(&porta,0); // 3-8     ( 8      )
if (dtn==2) {if (t & 0x8000) {tz3=1; t=~t+1;} else {tz3=0; t=t;}} //    3   
if (dt1[dtn][0]==0x28) // DS18B20
{
tc[dtn]=t>>4; //   
z1=t<<0; z1&=0x000f; z1*=625; td[dtn]=z1/1000; //   ( )  
}
else // DS18S20
{
tc[dtn]=t>>1; //   
ak1[0]=t<<7; if (ak1[0]==128) td[dtn]=5; else td[dtn]=0; //   ( )  
}
}

void eepr() //   eeprom  
{
pd1=eeprom_read(0x00); // /
pd2=eeprom_read(0x01); //  
inf=eeprom_read(0x02); //  
for (i=0; i<3; i++) {for (ak1[0]=0; ak1[0]<8; ak1[0]++) dt1[i][ak1[0]]=eeprom_read(ak1[0]+0x03+i*8);} //  1..3
for (i=0; i<16; i++)
{
hh[i]=eeprom_read(i+0x27); // /    1,2
mm[i]=eeprom_read(i+0x37); // /    1,2
kr[i]=eeprom_read(i+0x55); //      1,2
}
for (i=0; i<2; i++)
{
chv[i]=eeprom_read(i+0x1b); //     1,2
msv[i]=eeprom_read(i+0x1d); //     1,2
gdv[i]=eeprom_read(i+0x1f); //     1,2
chf[i]=eeprom_read(i+0x21); //     1,2
msf[i]=eeprom_read(i+0x23); //     1,2
gdf[i]=eeprom_read(i+0x25); //     1,2
ts[i]=eeprom_read(i+0x47);  //    1,2
tsv[i]=eeprom_read(i+0x49); //  1,2 /
fp[i]=eeprom_read(i+0x4b);  //      1,2
flv[i]=eeprom_read(i+0x4d); //   1,2 /
vzr[i]=eeprom_read(i+0x4f); //     1,2
vzp[i]=eeprom_read(i+0x51); //     1,2
vzv[i]=eeprom_read(i+0x53); // /   1,2
}
for (i=0; i<4; i++)
{
sb1[i]=eeprom_read(i+0x6c); //  sb1 ( )
sb2[i]=eeprom_read(i+0x70); //  sb2 ( )
sb3[i]=eeprom_read(i+0x74); //  sb3 ( )
sb4[i]=eeprom_read(i+0x78); //  sb4 ( )
sb5[i]=eeprom_read(i+0x7c); //  sb5 ( )
t11[i]=eeprom_read(i+0x80); //  ( )     1 ( 1)
t12[i]=eeprom_read(i+0x84); //  ( )     1 ( 2)
t21[i]=eeprom_read(i+0x88); //  ( )     2 ( 1)
t22[i]=eeprom_read(i+0x8c); //  ( )     2 ( 2)
fl1[i]=eeprom_read(i+0x90); //  ( )     ( 1)
fl2[i]=eeprom_read(i+0x94); //  ( )     ( 2)
vz1[i]=eeprom_read(i+0x98); //  ( )     ( 1)
vz2[i]=eeprom_read(i+0x9c); //  ( )     ( 2)
kr1[i]=eeprom_read(i+0xa0); //  ( )     ( 1)
kr2[i]=eeprom_read(i+0xa4); //  ( )     ( 2)
}
vgr=eeprom_read(0x65); //()  () 
ngr=eeprom_read(0x66); //()  () 
grv=eeprom_read(0x67); //()  /
ot=eeprom_read(0x68); //  
sp=eeprom_read(0x69); //  
irv=eeprom_read(0x6a); //  /
irm=eeprom_read(0x6b); //    
}

void menu0() //  
{
kp6=0; kp7=0; //  SB4  SB5  
if (in1==1) {inf=eeprom_read(0x02); in1=0; nms=inf;}
but1(5); // 
if (bt2==1) {inf=nms; eeprom_write(0x02,inf); bt2=0;} //     
bytetostr(hht,tx1); if (hht<10) tx1[1]=0x30; tx2[0]=tx1[1]; tx2[1]=tx1[2]; //  ()
bytetostr(mmt,tx1); if (mmt<10) tx1[1]=0x30; tx2[3]=tx1[1]; tx2[4]=tx1[2]; //  ()
bytetostr(sst,tx1); if (sst<10) tx1[1]=0x30; tx2[6]=tx1[1]; tx2[7]=tx1[2]; //  ()
tx2[2]=0x3a; tx2[5]=0x3a; tx2[8]=0x20; tx2[9]=0x20;
if (nd[0]==16) // -    
{
bytetostr(tc[0],tx1); tx2[10]=tx1[1]; tx2[11]=tx1[2]; //    ( 1)
bytetostr(td[0],tx1); tx2[13]=tx1[2]; //    ( 1)
}
else
{
tx2[10]=0x2d; tx2[11]=0x2d; tx2[13]=0x2d;
}
tx2[12]=0x2e; tx2[14]=0x00; tx2[15]=0x43;
stroka(1); //  

if (inf==1) //       ( 2)
{
bytetostr(chd,tx1); if (chd<10) tx1[1]=0x30; tx2[0]=tx1[1]; tx2[1]=tx1[2]; //  
bytetostr(msd,tx1); if (msd<10) tx1[1]=0x30; tx2[3]=tx1[1]; tx2[4]=tx1[2]; //  
bytetostr(gdd,tx1); if (gdd<10) tx1[1]=0x30; tx2[6]=tx1[1]; tx2[7]=tx1[2]; //  
tx2[2]=0x2e; tx2[5]=0x2e; tx2[8]=0x20; tx2[9]=0x20;
if (nd[1]==16) // -    
{
bytetostr(tc[1],tx1); tx2[10]=tx1[1]; tx2[11]=tx1[2]; //    ( 2)
bytetostr(td[1],tx1); tx2[13]=tx1[2]; //    ( 2)
}
else
{
tx2[10]=0x2d; tx2[11]=0x2d; tx2[13]=0x2d;
}
tx2[12]=0x2e; tx2[14]=0x00; tx2[15]=0x43;
}
if (inf==2) //     ( 2)
{
tx2[0]=0x20; tx2[1]=0x20; tx2[2]=0x20; tx2[3]=0x20; tx2[4]=0x20;
if (nd[1]==16) // -    
{
bytetostr(tc[1],tx1); tx2[5]=tx1[1]; tx2[6]=tx1[2]; //    ( 2)
bytetostr(td[1],tx1); tx2[8]=tx1[2]; //    ( 2)
}
else
{
tx2[5]=0x2d; tx2[6]=0x2d; tx2[8]=0x2d;
}
tx2[7]=0x2e; tx2[9]=0x00; tx2[10]=0x43; tx2[11]=0x20; tx2[12]=0x20; tx2[13]=0x20; tx2[14]=0x20; tx2[15]=0x20;
}
if (inf==3) //    
{
tx2[0]=0x20; tx2[1]=0x20; tx2[2]=0x20; tx2[3]=0x20;
bytetostr(chd,tx1); if (chd<10) tx1[1]=0x30; tx2[4]=tx1[1];  tx2[5]=tx1[2];  //  
bytetostr(msd,tx1); if (msd<10) tx1[1]=0x30; tx2[7]=tx1[1];  tx2[8]=tx1[2];  //  
bytetostr(gdd,tx1); if (gdd<10) tx1[1]=0x30; tx2[10]=tx1[1]; tx2[11]=tx1[2]; //  
tx2[6]=0x2e; tx2[9]=0x2e;
tx2[12]=0x20; tx2[13]=0x20; tx2[14]=0x20; tx2[15]=0x20;
}
if (inf==4) //     ( 3)   ( 2)
{
if (nd[2]==16) // -    
{
bytetostr(tc[2],tx1); tx2[1]=tx1[1]; tx2[2]=tx1[2]; //    ( 3)
bytetostr(td[2],tx1); tx2[4]=tx1[2]; //    ( 3)
if (tc[2]<10) {tx2[0]=0x20; if (tz3==1) tx2[1]=0x2d; else tx2[1]=0x20;} else {if (tz3==1) tx2[0]=0x2d; else tx2[0]=0x20;} //  
}
else
{
tx2[0]=0x20; tx2[1]=0x2d; tx2[2]=0x2d; tx2[4]=0x2d;
}
tx2[3]=0x2e; tx2[5]=0x00; tx2[6]=0x43; tx2[7]=0x20; tx2[8]=0x20; tx2[9]=0x20;
if (nd[1]==16) // -    
{
bytetostr(tc[1],tx1); tx2[10]=tx1[1]; tx2[11]=tx1[2]; //    ( 2)
bytetostr(td[1],tx1); tx2[13]=tx1[2]; //    ( 2)
}
else
{
tx2[10]=0x2d; tx2[11]=0x2d; tx2[13]=0x2d;
}
tx2[12]=0x2e; tx2[14]=0x00; tx2[15]=0x43;
}
if (inf==5) //  
{
for (i=0; i<16; i++) tx2[i]=0x20;
}
stroka(2); //  

if (bt1==1) {mnu=1;  nms=1; bt1=0; bt3=0;} //  
if (bt3==1) {mnu=17; nms=1; bt3=0;} //      
if (bt4==1)  bt4=0; //      
if (bt5==1) {mnu=18; nms=1; bt3=0; bt5=0;} //    
}

void menu1() // ""
{
kp6=0; kp7=0; //  SB4  SB5  
but1(4); // 
if (nms==1 || nms==2) //  ""  " "
{
if (nms==1) tx2[0]=0xc9; else tx2[0]=0x20; //   ""
tx2[1]=0x4f; tx2[2]=0x63;  tx2[3]=0xbd;  tx2[4]=0x6f;  tx2[5]=0x02;  tx2[6]=0xbd;  tx2[7]=0xc3; tx2[8]=0x65;
tx2[9]=0x20; tx2[10]=0x20; tx2[11]=0x20; tx2[12]=0x20; tx2[13]=0x20; tx2[14]=0x20; tx2[15]=0x20;
stroka(1); //  
if (nms==2) tx2[0]=0xc9; else tx2[0]=0x20; //   " "
tx2[1]=0xa5; tx2[2]=0x4b; tx2[3]=0x20; tx2[4]=0xbe; tx2[5]=0x6f; tx2[6]=0x70; tx2[7]=0xbf; tx2[8]=0x20;
stroka(2); //  
}
if (nms==3 || nms==4) //  " 1"  " 2"
{
if (nms==3) tx2[0]=0xc9; else tx2[0]=0x20; //   " 1"
tx2[1]=0x41; tx2[2]=0x03;  tx2[3]=0x02;  tx2[4]=0x61;  tx2[5]=0x70;  tx2[6]=0xb8;  tx2[7]=0x79; tx2[8]=0xbc;
tx2[9]=0x20; tx2[10]=0x31; tx2[11]=0x20; tx2[12]=0x20; tx2[13]=0x20; tx2[14]=0x20; tx2[15]=0x20;
stroka(1); //  
if (nms==4) tx2[0]=0xc9; else tx2[0]=0x20; //   " 2"
tx2[10]=0x32;
stroka(2); //  
}
if (bt1==1) {mnu=0; bt1=0; bt2=0; bt3=0; in1=1;} //    
bt4=0; //   1  
if (bt5==1)
{
if (nms==1)  mnu=2;  //   ""
if (nms==2)  mnu=8;  //   " "
if (nms==3) {mnu=11; dt4[0]=1;} //   " 1"  dt4[0]- 
if (nms==4) {mnu=11; dt4[0]=2;} //   " 2"
nms=1; bt2=0; bt3=0; bt5=0;
}
}

void menu2() // ""
{
kp6=0; kp7=0; //  SB4  SB5  
but1(5); // 
if (nms==1 || nms==2) //  "()"  ""
{
if (nms==1) tx2[0]=0xc9; else tx2[0]=0x20; //   "()"
tx2[1]=0xab; tx2[2]=0x61;  tx2[3]=0x63;  tx2[4]=0xc3;  tx2[5]=0x28;  tx2[6]=0xe0;  tx2[7]=0x61; tx2[8]=0xbf;
tx2[9]=0x61; tx2[10]=0x29; tx2[11]=0x20; tx2[12]=0x20; tx2[13]=0x20; tx2[14]=0x20; tx2[15]=0x20;
stroka(1); //  
if (nms==2) tx2[0]=0xc9; else tx2[0]=0x20; //   ""
tx2[1]=0xe0; tx2[2]=0x61; tx2[3]=0xbf; tx2[4]=0xc0; tx2[5]=0xb8; tx2[6]=0x03; tx2[7]=0xb8; tx2[8]=0x20;
tx2[9]=0x20; tx2[10]=0x20;
stroka(2); //  
}
if (nms==3 || nms==4) //  " "  ""
{
if (nms==3) tx2[0]=0xc9; else tx2[0]=0x20; //   " "
tx2[1]=0xa1; tx2[2]=0x70;  tx2[3]=0x61;  tx2[4]=0xbd;  tx2[5]=0xb8;  tx2[6]=0xe5;  tx2[7]=0xc3; tx2[8]=0x20;
tx2[9]=0x70; tx2[10]=0x65; tx2[11]=0xb6; tx2[12]=0xb8; tx2[13]=0xbc; tx2[14]=0x6f; tx2[15]=0x02;
stroka(1); //  
if (nms==4) tx2[0]=0xc9; else tx2[0]=0x20; //   ""
tx2[1]=0x4b; tx2[2]=0x6f;  tx2[3]=0x70;  tx2[4]=0x70;  tx2[5]=0x65;  tx2[6]=0x03;  tx2[7]=0xe5; tx2[8]=0xb8;
tx2[9]=0xc7; tx2[10]=0x20; tx2[11]=0x20; tx2[12]=0x20; tx2[13]=0x20; tx2[14]=0x20; tx2[15]=0x20;
stroka(2); //  
}
if (nms==5) //  ""
{
if (nms==5) tx2[0]=0xc9; //   ""
tx2[1]=0xa8; tx2[2]=0x6f;  tx2[3]=0xe3;  tx2[4]=0x63;  tx2[5]=0x02;  tx2[6]=0x65;  tx2[7]=0xbf; tx2[8]=0x03;
tx2[9]=0x61; tx2[10]=0x20; tx2[11]=0x20; tx2[12]=0x20; tx2[13]=0x20; tx2[14]=0x20; tx2[15]=0x20;
stroka(1); //  
for (i=0; i<16; i++) tx2[i]=0x20;
stroka(2); //  
}
if (bt1==1) {mnu=1; nms=1; bt1=0; bt2=0; bt3=0;} //    ""
bt4=0; //   1  
if (bt5==1)
{
if (nms==1)  mnu=3; //   "()"
if (nms==2)  mnu=4; //   ""
if (nms==3)  mnu=5; //   " "
if (nms==4)  mnu=6; //   ""
if (nms==5)  mnu=7; //   ""
nms=1; bt2=0; bt3=0; bt5=0;
}
}

void menu3() // "()"
{
kp6=1; kp7=1; //  SB4  SB5 
but1(6); // 
tx2[0]=0xab; tx2[1]=0x61; tx2[2]=0x63; tx2[3]=0xc3; tx2[4]=0x20; tx2[8]=0x20; tx2[12]=0x20;
if (nms<4)  // 
{
if (nms==1) {tx2[5]=0xc9; tx2[9]=0x20; tx2[13]=0x20; if (bt4==1) {hht++; if (hht>23) hht=0;} if (bt5==1) {hht--; if (hht>23) hht=23;} dt4[0]=hht;} //  ()
if (nms==2) {tx2[5]=0x20; tx2[9]=0xc9; tx2[13]=0x20; if (bt4==1) {mmt++; if (mmt>59) mmt=0;} if (bt5==1) {mmt--; if (mmt>59) mmt=59;} dt4[0]=mmt;} //  ()
if (nms==3) {tx2[5]=0x20; tx2[9]=0x20; tx2[13]=0xc9; bt4=0; if (bt5==1) {sst=0; dt4[0]=sst;}} // 
if (bt4==1 || bt5==1) //  DS1307     
{
dt4[0]=Dec2Bcd(dt4[0]); //Dec2Bcd -     
soft_i2c_start();       //    DS1307
soft_i2c_write(0xd0);   //   
soft_i2c_write(3-nms);  //    
soft_i2c_write(dt4[0]); //  
soft_i2c_stop();        // 
bt4=0; bt5=0;
}
}
if (nms>3)  {tx2[5]=0x20; tx2[9]=0x20; tx2[13]=0x20;} //  
bytetostr(hht,tx1); if (hht<10) tx1[1]=0x30; tx2[6]=tx1[1];  tx2[7]=tx1[2];  //  ()
bytetostr(mmt,tx1); if (mmt<10) tx1[1]=0x30; tx2[10]=tx1[1]; tx2[11]=tx1[2]; //  ()
bytetostr(sst,tx1); if (sst<10) tx1[1]=0x30; tx2[14]=tx1[1]; tx2[15]=tx1[2]; //  ()
stroka(1); //  

tx2[0]=0xe0; tx2[1]=0x61; tx2[2]=0xbf; tx2[3]=0x61;
if (nms>3) // 
{
if (msd==1 || msd==3 || msd==5 || msd==7 || msd==8 || msd==10 || msd==12) dt4[0]=31; //    
if (msd==4 || msd==6 || msd==9 || msd==11) dt4[0]=30;
if (msd==2) {if (gdd%4) dt4[0]=28; else dt4[0]=29;} //  
if (nms==4) {tx2[5]=0xc9; tx2[9]=0x20; tx2[13]=0x20; if (bt4==1) {chd++; if (chd>dt4[0]) chd=1;} if (bt5==1) {chd--; if (chd<1) chd=dt4[0];} dt4[1]=chd;} //  
if (nms==5) {tx2[5]=0x20; tx2[9]=0xc9; tx2[13]=0x20; if (bt4==1) {msd++; if (msd>12) msd=1;} if (bt5==1) {msd--; if (msd<1) msd=12;} dt4[1]=msd;} // 
if (nms==6) {tx2[5]=0x20; tx2[9]=0x20; tx2[13]=0xc9; if (bt4==1) {gdd++; if (gdd>24 || gdd<12) gdd=12;} if (bt5==1) {gdd--; if (gdd<12 || gdd>24) gdd=24;} dt4[1]=gdd;} // 
if (bt4==1 || bt5==1) //  DS1307     
{
dt4[1]=Dec2Bcd(dt4[1]); //Dec2Bcd -     
soft_i2c_start();       //    DS1307
soft_i2c_write(0xd0);   //   
soft_i2c_write(nms);    //    
soft_i2c_write(dt4[1]); //  
soft_i2c_stop();        // 
bt4=0; bt5=0;
}
}
if (nms<4)  {tx2[5]=0x20; tx2[9]=0x20; tx2[13]=0x20;} //  
bytetostr(chd,tx1); if (chd<10) tx1[1]=0x30; tx2[6]=tx1[1];  tx2[7]=tx1[2];  //  
bytetostr(msd,tx1); if (msd<10) tx1[1]=0x30; tx2[10]=tx1[1]; tx2[11]=tx1[2]; //  
bytetostr(gdd,tx1); if (gdd<10) tx1[1]=0x30; tx2[14]=tx1[1]; tx2[15]=tx1[2]; //  
stroka(2); //  

if (bt1==1) {mnu=2; nms=1; bt1=0; bt2=0; bt3=0;} //    "()"
}

void menu4() // ""
{
kp6=0; kp7=0; //  SB4  SB5  
but1(3); // 
tx2[0]=0x20; tx2[1]=0x20; tx2[2]=0x20;  tx2[3]=0x20;  tx2[4]=0xe0;  tx2[5]=0x61;  tx2[6]=0xbf;  tx2[7]=0xc0;
tx2[8]=0xb8; tx2[9]=0x03; tx2[10]=0x20; tx2[12]=0x20; tx2[13]=0x20; tx2[14]=0x20; tx2[15]=0x20;
bytetostr(nms,tx1); tx2[11]=tx1[2];
stroka(1); //  
bt4=0; //   1  
if (bt5==1)
{
ow_reset(&porta,0); //  1-Wire
ow_write(&porta,0,0x33); //     
delay_us(500);
for (i=0; i<8; i++) {dt1[nms-1][i]=ow_read(&porta,0); dt4[i]=dt1[nms-1][i]; eeprom_write(i+0x03+(nms-1)*8,dt1[nms-1][i]);}
bt5=0;
}
for (i=0; i<8; i++) dt4[i]=dt1[nms-1][i];
for (i=0; i<8; i++) {bytetohex(dt4[i],tx1); tx2[i*2]=tx1[0]; tx2[i*2+1]=tx1[1];} // 
stroka(2); //  
if (bt1==1) {mnu=2; nms=2; bt1=0; bt2=0; bt3=0;} //    ""
}

void menu5() // " "
{
if (nms==3) {kp6=0; kp7=0;} //  SB4  SB5  
else        {kp6=1; kp7=1;} //  SB4  SB5 
but1(3); // 
tx2[0]=0x20; tx2[1]=0xa1; tx2[2]=0x70;  tx2[3]=0x61;  tx2[4]=0xbd;  tx2[5]=0xb8;  tx2[6]=0xe5;  tx2[7]=0xc3;
tx2[8]=0x20; tx2[9]=0x70; tx2[10]=0x65; tx2[11]=0xb6; tx2[12]=0xb8; tx2[13]=0xbc; tx2[14]=0x6f; tx2[15]=0x02;
stroka(1); //  

if (nms==1)
{
tx2[0]=0xc9; tx2[7]=0x20; tx2[14]=0x20; //   
if (bt4==1) {vgr++; if (vgr>23) vgr=19; eeprom_write(0x65,vgr); bt4=0;} //  
if (bt5==1) {vgr--; if (vgr<19) vgr=23; eeprom_write(0x65,vgr); bt5=0;} //  
}
if (nms==2)
{
tx2[0]=0x20; tx2[7]=0xc9; tx2[14]=0x20; //   
if (bt4==1) {ngr++; if (ngr>10) ngr=6;  eeprom_write(0x66,ngr); bt4=0;} //  
if (bt5==1) {ngr--; if (ngr<6)  ngr=10; eeprom_write(0x66,ngr); bt5=0;} //  
}
if (nms==3)
{
bt4=0; //   1  
tx2[0]=0x20; tx2[7]=0x20; tx2[14]=0xc9; //  / 
if (bt5==1) {if (grv==1) grv=0; else grv=1; eeprom_write(0x67,grv); bt5=0;} /// () 
}

tx2[1]=0x42; tx2[2]=0x2e; tx2[5]=0x20; tx2[6]=0x20; tx2[8]=0x48; tx2[9]=0x2e; tx2[12]=0x20; tx2[13]=0x20;
bytetostr(vgr,tx1); tx2[3]=tx1[1]; tx2[4]=tx1[2];  //  
bytetostr(ngr,tx1); if (ngr<10) {tx2[10]=tx1[2]; tx2[11]=0x20;} else {tx2[10]=tx1[1]; tx2[11]=tx1[2];} //  
if (grv==1) tx2[15]=0xd9; else tx2[15]=0xda; // / 
stroka(2); //  

if (bt1==1) {mnu=2; nms=3; bt1=0; bt2=0; bt3=0;} //    " "
}

void menu6() // ""
{
kp6=1; kp7=1; //  SB4  SB5 
but1(2); // 
tx2[0]=0x20; tx2[1]=0x20; tx2[2]=0x20;  tx2[3]=0x4b;  tx2[4]=0x6f;  tx2[5]=0x70;  tx2[6]=0x70;  tx2[7]=0x65;
tx2[8]=0x03; tx2[9]=0xe5; tx2[10]=0xb8; tx2[11]=0xc7; tx2[12]=0x20; tx2[13]=0x20; tx2[14]=0x20; tx2[15]=0x20;
stroka(1); //  

if (nms==1)
{
tx2[0]=0xc9; tx2[9]=0x20; //   
if (bt4==1) {ot++; if (ot>25) ot=0;  eeprom_write(0x68,ot); bt4=0;} //  
if (bt5==1) {ot--; if (ot>25) ot=25; eeprom_write(0x68,ot); bt5=0;} //  
}
else
{
tx2[0]=0x20; tx2[9]=0xc9; //   
if (bt4==1) {sp++; if (sp>25) sp=0;  eeprom_write(0x69,sp); bt4=0;} //  
if (bt5==1) {sp--; if (sp>25) sp=25; eeprom_write(0x69,sp); bt5=0;} //  
}

tx2[1]=0x4f; tx2[2]=0xbf;  tx2[3]=0x63;  tx2[4]=0x2e;  tx2[7]=0x20;
tx2[8]=0x20; tx2[10]=0x43; tx2[11]=0xbe; tx2[12]=0x65; tx2[13]=0x2e;
bytetostr(ot,tx1); if (ot<10) {tx2[5]=tx1[2];  tx2[6]=0x20;}  else {tx2[5]=tx1[1];  tx2[6]=tx1[2];}  //    ()
bytetostr(sp,tx1); if (sp<10) {tx2[14]=tx1[2]; tx2[15]=0x20;} else {tx2[14]=tx1[1]; tx2[15]=tx1[2];} //    ()
stroka(2); //  

if (bt1==1) {mnu=2; nms=4; bt1=0; bt2=0; bt3=0;} //    ""
}

void menu7() // ""
{
if (nms==2) {kp6=0; kp7=0;} //  SB4  SB5  
else        {kp6=1; kp7=1;} //  SB4  SB5 
but1(2); // 
tx2[0]=0x20; tx2[1]=0x20; tx2[2]=0x20;  tx2[3]=0xa8;  tx2[4]=0x6f;  tx2[5]=0xe3;  tx2[6]=0x63;  tx2[7]=0x02;
tx2[8]=0x65; tx2[9]=0xbf; tx2[10]=0x03; tx2[11]=0x61; tx2[12]=0x20; tx2[13]=0x20; tx2[14]=0x20; tx2[15]=0x20;
stroka(1); //  

if (nms==1)
{
tx2[0]=0xc9; tx2[14]=0x20;//     
if (bt4==1) {pd2++; if (pd2>20) pd2=5;  eeprom_write(0x01,pd2); bt4=0;} //   
if (bt5==1) {pd2--; if (pd2<5)  pd2=20; eeprom_write(0x01,pd2); bt5=0;} //   
}
else
{
tx2[0]=0x20; tx2[14]=0xc9; //  / 
bt4=0; //   1  
if (bt5==1) {if (pd1==0) pd1=1; else pd1=0; eeprom_write(0x00,pd1); bt5=0;} /// 
}
tx2[1]=0x50; tx2[2]=0x61; tx2[3]=0xb2;  tx2[4]=0x6f;  tx2[5]=0xbf;
tx2[6]=0x61; tx2[7]=0x20; tx2[10]=0x20; tx2[11]=0x20; tx2[12]=0x20; tx2[13]=0x20;
bytetostr(pd2,tx1); if (pd2<10) {tx2[8]=tx1[2]; tx2[9]=0x20;} else {tx2[8]=tx1[1]; tx2[9]=tx1[2];}  //   
if (pd1==1) tx2[15]=0xd9; else tx2[15]=0xda; // / 
stroka(2); //  

if (bt1==1) {mnu=2; nms=5; bt1=0; bt2=0; bt3=0;} //    ""
}


void menu8() // " "
{
kp6=0; kp7=0; //  SB4  SB5  
but1(3); // 
if (nms==1 || nms==2) //  " "  ""
{
if (nms==1) tx2[0]=0xc9; else tx2[0]=0x20; //   " "
tx2[1]=0xa5; tx2[2]=0x4b;  tx2[3]=0x20;  tx2[4]=0xbe;  tx2[5]=0x6f;  tx2[6]=0x70;  tx2[7]=0xbf; tx2[8]=0x20;
tx2[9]=0x20; tx2[10]=0x20; tx2[11]=0x20; tx2[12]=0x20; tx2[13]=0x20; tx2[14]=0x20;
if (irv==1) tx2[15]=0xd9; else tx2[15]=0xda;
stroka(1); //  
if (nms==2) tx2[0]=0xc9; else tx2[0]=0x20; //   ""
tx2[1]=0x4b; tx2[2]=0x6f;  tx2[3]=0xe3;  tx2[4]=0xb8; tx2[5]=0x70; tx2[6]=0x6f; tx2[7]=0x02; tx2[8]=0x61;
tx2[9]=0xbd; tx2[10]=0xb8; tx2[11]=0x65; tx2[15]=0x20;
stroka(2); //  
}
if (nms==3) //  " "
{
tx2[0]=0xc9; tx2[1]=0x48; tx2[2]=0x61;  tx2[3]=0xb7;  tx2[4]=0xbd;  tx2[5]=0x2d;  tx2[6]=0xbd;  tx2[7]=0xb8;
tx2[8]=0x65; tx2[9]=0x20; tx2[10]=0x03; tx2[11]=0xbd; tx2[12]=0x6f; tx2[13]=0xbe; tx2[14]=0x6f; tx2[15]=0x03;
stroka(1); //  
for (i=0; i<16; i++) tx2[i]=0x20;
stroka(2); //  
}

if (bt1==1) {mnu=1; nms=2; bt1=0; bt2=0; bt3=0;} //    " "
bt4=0; //   1  
if (bt5==1)
{
if (nms==1) {if (irv==0) irv=1; else {irv=0; sbk[0]=0; sbk[1]=0; sbk[2]=0; sbk[3]=0;} eeprom_write(0x6a,irv);} // /
if (nms==2) {sbk[0]=0; sbk[1]=0; sbk[2]=0; sbk[3]=0; mnu=9; in1=1;} //   ""
if (nms==3) {sbk[0]=0; sbk[1]=0; sbk[2]=0; sbk[3]=0; mnu=10; dt4[0]=0; dt4[1]=0;} //   " "
nms=1; bt5=0; bt2=0; bt3=0;
}
}

void menu9() // ""
{
kp6=0; kp7=0; //  SB4  SB5  
if (in1==1) {irm=eeprom_read(0x6b); in1=0; nms=irm;}
but1(3); // 
if (bt2==1 || bt3==1) {irm=nms; eeprom_write(0x6b,irm); bt2=0; bt3=0; sbk[0]=0; sbk[1]=0; sbk[2]=0; sbk[3]=0;}
tx2[0]=0x20; tx2[1]=0x20; tx2[2]=0x20; tx2[3]=0x20; tx2[12]=0x20; tx2[13]=0x20; tx2[14]=0x20; tx2[15]=0x20;
tx2[4]=0x50; tx2[5]=0x65; tx2[6]=0xb6; tx2[7]=0xb8; tx2[8]=0xbc;  tx2[9]=0x20;  tx2[10]=0x20;
bytetostr(nms,tx1); tx2[11]=tx1[2]; //- 1 //- 2 //- 3
stroka(1); //  
for (i=0; i<4; i++) {bytetohex(sbk[i],tx1); tx2[i*2+4]=tx1[0]; tx2[i*2+5]=tx1[1];} // 
stroka(2); //  

if (bt1==1) {mnu=8; nms=2; bt1=0; sbk[0]=0; sbk[1]=0; sbk[2]=0; sbk[3]=0;} //    " "
bt4=0; //   1  
bt5=0; //   1  
}

void menu10() // " "
{
kp6=0; kp7=0; //  SB4  SB5  
but1(15); // 
tx2[0]=0x20; tx2[1]=0x20; tx2[13]=0x20; tx2[14]=0x20; tx2[15]=0x20;
if (nms==1) {tx2[2]=0x20; tx2[3]=0x42; tx2[4]=0x78; tx2[5]=0x6f; tx2[6]=0xe3; tx2[7]=0x2d; tx2[8]=0x02; tx2[9]=0xc3; tx2[10]=0x78; tx2[11]=0x6f; tx2[12]=0xe3;} // "-"
if (nms==2) {tx2[2]=0x42; tx2[3]=0xbd; tx2[4]=0xb8; tx2[5]=0xb7; tx2[6]=0x2d; tx2[7]=0x02; tx2[8]=0xbe; tx2[9]=0x70; tx2[10]=0x61; tx2[11]=0x02; tx2[12]=0x6f;} // "-"
if (nms==3) {tx2[2]=0x42; tx2[3]=0x02; tx2[4]=0x65; tx2[5]=0x70; tx2[6]=0x78; tx2[7]=0x2d; tx2[8]=0x02; tx2[9]=0xbb; tx2[10]=0x65; tx2[11]=0x02; tx2[12]=0x6f;} // "-"
if (nms==4) {tx2[2]=0x20; tx2[3]=0x20; tx2[4]=0x20; tx2[5]=0x20; tx2[6]=0x20; tx2[7]=0x2b; tx2[8]=0x31; tx2[9]=0x20; tx2[10]=0x20; tx2[11]=0x20; tx2[12]=0x20;} // "+1"
if (nms==5) {tx2[2]=0x20; tx2[3]=0x20; tx2[4]=0x2d; tx2[5]=0x31; tx2[6]=0x28; tx2[7]=0x02; tx2[8]=0x78; tx2[9]=0x6f; tx2[10]=0xe3; tx2[11]=0x29; tx2[12]=0x20;} // "-1()"

if (nms>5 && nms<10) // ""
{
tx2[0]=0x54; tx2[1]=0x61; tx2[2]=0x01;  tx2[3]=0xbc;  tx2[4]=0x65;  tx2[5]=0x70;  tx2[6]=0x20;
tx2[8]=0x20; tx2[9]=0x28; tx2[10]=0x41; tx2[11]=0x03; tx2[12]=0x02; tx2[13]=0x2e; tx2[15]=0x29;
if (nms==6 || nms==7) tx2[7]=0x31;  else tx2[7]=0x32;  // 
if (nms==6 || nms==8) tx2[14]=0x31; else tx2[14]=0x32; // 
}
if (nms>9 && nms<14) // ""  ""
{
if (nms==10 || nms==11) 
{tx2[1]=0xaa; tx2[2]=0xb8; tx2[3]=0xbb; tx2[4]=0x04; tx2[5]=0xbf; tx2[6]=0x70;} // ""
else
{tx2[1]=0x42; tx2[2]=0x6f; tx2[3]=0xb7; tx2[4]=0xe3; tx2[5]=0x79; tx2[6]=0x78;} // ""
tx2[0]=0x20; tx2[7]=0x20; tx2[8]=0x28; tx2[9]=0x41; tx2[10]=0x03; tx2[11]=0x02; tx2[12]=0x2e; tx2[14]=0x29; tx2[15]=0x20;
if (nms==10 || nms==12) tx2[13]=0x31; else tx2[13]=0x32; // 
}
if (nms==14 || nms==15) // ""
{
tx2[0]=0x4b; tx2[1]=0x6f; tx2[2]=0x70;  tx2[3]=0xbc;  tx2[4]=0x79;  tx2[5]=0xc1;  tx2[6]=0x03; tx2[7]=0x61;
tx2[8]=0x20; tx2[9]=0x28; tx2[10]=0x41; tx2[11]=0x03; tx2[12]=0x02; tx2[13]=0x2e; tx2[15]=0x29;
if (nms==14) tx2[14]=0x31; else tx2[14]=0x32; // 
}
stroka(1); //  

if (dt4[1]==1) dt4[0]++; if (dt4[0]>3) dt4[1]=0;
tx2[1]=0x20; tx2[2]=0x20; tx2[3]=0x20; tx2[12]=0x20; tx2[13]=0x20; tx2[14]=0x20;
if (bt2==1 || bt3==1) {dt4[0]=0; dt4[1]=0; bt2=0; bt3=0;}
bt4=0; //   1  

if (bt5==1)
{
dt4[0]=0; dt4[1]=1;
if (nms==1)  {sb1[0]=sbk[0]; sb1[1]=sbk[1]; sb1[2]=sbk[2]; sb1[3]=sbk[3]; dt4[2]=0x6c;} //   "-"
if (nms==2)  {sb2[0]=sbk[0]; sb2[1]=sbk[1]; sb2[2]=sbk[2]; sb2[3]=sbk[3]; dt4[2]=0x70;} //   "-"
if (nms==3)  {sb3[0]=sbk[0]; sb3[1]=sbk[1]; sb3[2]=sbk[2]; sb3[3]=sbk[3]; dt4[2]=0x74;} //   "-"
if (nms==4)  {sb4[0]=sbk[0]; sb4[1]=sbk[1]; sb4[2]=sbk[2]; sb4[3]=sbk[3]; dt4[2]=0x78;} //   "+1"
if (nms==5)  {sb5[0]=sbk[0]; sb5[1]=sbk[1]; sb5[2]=sbk[2]; sb5[3]=sbk[3]; dt4[2]=0x7c;} //   "-1()"
if (nms==6)  {t11[0]=sbk[0]; t11[1]=sbk[1]; t11[2]=sbk[2]; t11[3]=sbk[3]; dt4[2]=0x80;} //   " 1  1"
if (nms==7)  {t12[0]=sbk[0]; t12[1]=sbk[1]; t12[2]=sbk[2]; t12[3]=sbk[3]; dt4[2]=0x84;} //   " 1  2"
if (nms==8)  {t21[0]=sbk[0]; t21[1]=sbk[1]; t21[2]=sbk[2]; t21[3]=sbk[3]; dt4[2]=0x88;} //   " 2  1"
if (nms==9)  {t22[0]=sbk[0]; t22[1]=sbk[1]; t22[2]=sbk[2]; t22[3]=sbk[3]; dt4[2]=0x8c;} //   " 2  2"
if (nms==10) {fl1[0]=sbk[0]; fl1[1]=sbk[1]; fl1[2]=sbk[2]; fl1[3]=sbk[3]; dt4[2]=0x90;} //   "  1"
if (nms==11) {fl2[0]=sbk[0]; fl2[1]=sbk[1]; fl2[2]=sbk[2]; fl2[3]=sbk[3]; dt4[2]=0x94;} //   "  2"
if (nms==12) {vz1[0]=sbk[0]; vz1[1]=sbk[1]; vz1[2]=sbk[2]; vz1[3]=sbk[3]; dt4[2]=0x98;} //   "  1"
if (nms==13) {vz2[0]=sbk[0]; vz2[1]=sbk[1]; vz2[2]=sbk[2]; vz2[3]=sbk[3]; dt4[2]=0x9c;} //   "  2"
if (nms==14) {kr1[0]=sbk[0]; kr1[1]=sbk[1]; kr1[2]=sbk[2]; kr1[3]=sbk[3]; dt4[2]=0xa0;} //   "  1"
if (nms==15) {kr2[0]=sbk[0]; kr2[1]=sbk[1]; kr2[2]=sbk[2]; kr2[3]=sbk[3]; dt4[2]=0xa4;} //   "  2"
for (i=0; i<4; i++) eeprom_write(i+dt4[2],sbk[i]);
bt5=0;
}
for (i=0; i<4; i++) {bytetohex(sbk[i],tx1); tx2[i*2+4]=tx1[0]; tx2[i*2+5]=tx1[1];} // 
if (dt4[1]==0) {tx2[0]=0xda; tx2[15]=0xda;} else {tx2[0]=0xd9; tx2[15]=0xd9;}
stroka(2); //  

if (bt1==1) {mnu=8; nms=3; bt1=0; bt2=0; bt3=0; sbk[0]=0; sbk[1]=0; sbk[2]=0; sbk[3]=0;} //    " "
}

void menu11() // " 1   2"
{
kp6=0; kp7=0; //  SB4  SB5  
but1(6); // 
if (nms==1 || nms==2) //  " 1"  " 2"
{
if (nms==1) tx2[0]=0xc9; else tx2[0]=0x20; //   " 1"
tx2[1]=0x54; tx2[2]=0x61;  tx2[3]=0x01;  tx2[4]=0xbc;  tx2[5]=0x65;  tx2[6]=0x70;  tx2[7]=0x20; tx2[8]=0x31;
tx2[9]=0x20; tx2[10]=0x20; tx2[11]=0x20; tx2[12]=0x20; tx2[13]=0x20; tx2[14]=0x20; tx2[15]=0x20;
stroka(1); //  
if (nms==2) tx2[0]=0xc9; else tx2[0]=0x20; //   " 2"
tx2[8]=0x32;
stroka(2); //  
}
if (nms==3 || nms==4) //  ""  ""
{
if (nms==3) tx2[0]=0xc9; else tx2[0]=0x20; //   ""
tx2[1]=0xaa; tx2[2]=0xb8;  tx2[3]=0xbb;  tx2[4]=0x04;  tx2[5]=0xbf;  tx2[6]=0x70;  tx2[7]=0x20; tx2[8]=0x20;
tx2[9]=0x20; tx2[10]=0x20; tx2[11]=0x20; tx2[12]=0x20; tx2[13]=0x20; tx2[14]=0x20; tx2[15]=0x20;
stroka(1); //  
if (nms==4) tx2[0]=0xc9; else tx2[0]=0x20; //   ""
tx2[1]=0x42; tx2[2]=0x6f; tx2[3]=0xb7; tx2[4]=0xe3; tx2[5]=0x79; tx2[6]=0x78;
stroka(2); //  
}
if (nms==5 || nms==6) //  ""  ""
{
if (nms==5) tx2[0]=0xc9; else tx2[0]=0x20; //   ""
tx2[1]=0x4b; tx2[2]=0x6f; tx2[3]=0x70;  tx2[4]=0xbc;  tx2[5]=0x79;  tx2[6]=0xc1;  tx2[7]=0x03;
tx2[8]=0x61; tx2[9]=0x20; tx2[10]=0x20; tx2[11]=0x20; tx2[12]=0x20; tx2[13]=0x20; tx2[14]=0x20; tx2[15]=0x20;
stroka(1); //  
if (nms==6) tx2[0]=0xc9; else tx2[0]=0x20; //   ""
tx2[1]=0x54; tx2[2]=0x65; tx2[5]=0x6f; tx2[6]=0x63; tx2[7]=0xbf; tx2[9]=0xbf;
stroka(2); //  
}
if (bt1==1) {mnu=1; if (dt4[0]==1) nms=3; else nms=4; bt1=0; bt2=0; bt3=0;} //    " 1   2"
bt4=0; //   1  
if (bt5==1)
{
if (nms==1) {mnu=12; dt4[1]=1; dt4[2]=0;} //   " 1"  dt4[2]-  dt4[1]- 
if (nms==2) {mnu=12; dt4[1]=2; dt4[2]=4;} //   " 2"  dt4[0]- 
if (nms==3)  mnu=13; //   ""
if (nms==4)  mnu=14; //   ""
if (nms==5)  mnu=15; //   ""
if (nms==6)  mnu=16; //   ""
nms=1; bt5=0; bt2=0; bt3=0;
}
}

void menu12() // " 1   2"
{
kp6=1; kp7=1; //  SB4  SB5 
but1(8); // 
if (dt4[0]==1) i=nms-nms/2+dt4[2]-1; else i=nms-nms/2+dt4[2]+7;
//nms=1; i=0; i=4; i=8;  i=12;
//nms=2; i=0; i=4; i=8;  i=12;
//nms=3; i=1; i=5; i=9;  i=13;
//nms=4; i=1; i=5; i=9;  i=13;
//nms=5; i=2; i=6; i=10; i=14;
//nms=6; i=2; i=6; i=10; i=14;
//nms=7; i=3; i=7; i=11; i=15;
//nms=8; i=3; i=7; i=11; i=15;
if (bt4==1)
{
if (nms==1 || nms==3 || nms==5 || nms==7) {hh[i]++; if (hh[i]>23) hh[i]=0; eeprom_write(i+0x27,hh[i]);}
if (nms==2 || nms==4 || nms==6 || nms==8) {mm[i]++; if (mm[i]>59) mm[i]=0; eeprom_write(i+0x37,mm[i]);}
bt4=0;
}
if (bt5==1)
{
if (nms==1 || nms==3 || nms==5 || nms==7) {hh[i]--; if (hh[i]>23) hh[i]=23; eeprom_write(i+0x27,hh[i]);}
if (nms==2 || nms==4 || nms==6 || nms==8) {mm[i]--; if (mm[i]>59) mm[i]=59; eeprom_write(i+0x37,mm[i]);}
bt5=0;
}
tx2[0]=0x54; tx2[7]=0xd9; tx2[8]=0x20; tx2[15]=0xd9;
if (nms==1) {tx2[1]=0xc9; tx2[4]=0x20; tx2[9]=0x20; tx2[12]=0x20;} //  1  
if (nms==2) {tx2[1]=0x20; tx2[4]=0xc9; tx2[9]=0x20; tx2[12]=0x20;} //  1  
if (nms==3 || nms==4 || nms==7 || nms==8) {tx2[1]=0x20; tx2[4]=0x20; tx2[9]=0x20; tx2[12]=0x20;} //  1  2    
if (nms==5) {tx2[1]=0x20; tx2[4]=0x20; tx2[9]=0xc9; tx2[12]=0x20;} //  2  
if (nms==6) {tx2[1]=0x20; tx2[4]=0x20; tx2[9]=0x20; tx2[12]=0xc9;} //  2  

if (dt4[0]==1) dt4[3]=dt4[2]; else dt4[3]=dt4[2]+8;
i=hh[dt4[3]];  bytetostr(i,tx1); if (i<10) tx1[1]=0x30; tx2[2]=tx1[1];  tx2[3]=tx1[2];  //  ( )
i=mm[dt4[3]];  bytetostr(i,tx1); if (i<10) tx1[1]=0x30; tx2[5]=tx1[1];  tx2[6]=tx1[2];  //  ( )
i=hh[dt4[3]+2];bytetostr(i,tx1); if (i<10) tx1[1]=0x30; tx2[10]=tx1[1]; tx2[11]=tx1[2]; //  ( )
i=mm[dt4[3]+2];bytetostr(i,tx1); if (i<10) tx1[1]=0x30; tx2[13]=tx1[1]; tx2[14]=tx1[2]; //  ( )
stroka(1); //  

bytetostr(dt4[1],tx1); tx2[0]=tx1[2]; tx2[7]=0xda; tx2[15]=0xda;
if (nms==3) {tx2[1]=0xc9; tx2[4]=0x20; tx2[9]=0x20; tx2[12]=0x20;} //  1  
if (nms==4) {tx2[1]=0x20; tx2[4]=0xc9; tx2[9]=0x20; tx2[12]=0x20;} //  1  
if (nms==1 || nms==2 || nms==5 || nms==6) {tx2[1]=0x20; tx2[4]=0x20; tx2[9]=0x20; tx2[12]=0x20;} //  1  2    
if (nms==7) {tx2[1]=0x20; tx2[4]=0x20; tx2[9]=0xc9; tx2[12]=0x20;} //  2  
if (nms==8) {tx2[1]=0x20; tx2[4]=0x20; tx2[9]=0x20; tx2[12]=0xc9;} //  2  

i=hh[dt4[3]+1];bytetostr(i,tx1); if (i<10) tx1[1]=0x30; tx2[2]=tx1[1];  tx2[3]=tx1[2];  //  ( )
i=mm[dt4[3]+1];bytetostr(i,tx1); if (i<10) tx1[1]=0x30; tx2[5]=tx1[1];  tx2[6]=tx1[2];  //  ( )
i=hh[dt4[3]+3];bytetostr(i,tx1); if (i<10) tx1[1]=0x30; tx2[10]=tx1[1]; tx2[11]=tx1[2]; //  ( )
i=mm[dt4[3]+3];bytetostr(i,tx1); if (i<10) tx1[1]=0x30; tx2[13]=tx1[1]; tx2[14]=tx1[2]; //  ( )
stroka(2); //  
if (bt1==1) {mnu=11; if (dt4[1]==1) nms=1; else nms=2; bt1=0; bt2=0; bt3=0;} //    " 1   2"
}

void menu13() // ""
{
if (nms==2) {kp6=0; kp7=0;} //  SB4  SB5  
else        {kp6=1; kp7=1;} //  SB4  SB5 
but1(2); // 
tx2[0]=0x20; tx2[1]=0x20; tx2[2]=0x20;  tx2[3]=0x20;  tx2[4]=0x20;  tx2[5]=0xaa;  tx2[6]=0xb8;  tx2[7]=0xbb;
tx2[8]=0x04; tx2[9]=0xbf; tx2[10]=0x70; tx2[11]=0x20; tx2[12]=0x20; tx2[13]=0x20; tx2[14]=0x20; tx2[15]=0x20;
stroka(1); //  

i=dt4[0]-1; //dt4[0]- 
if (nms==1)
{
tx2[1]=0xc9;tx2[12]=0x20; //     
if (bt4==1) {fp[i]++; if (fp[i]>20) fp[i]=1;  eeprom_write(i+0x4b,fp[i]); bt4=0;} //   
if (bt5==1) {fp[i]--; if (fp[i]<1)  fp[i]=20; eeprom_write(i+0x4b,fp[i]); bt5=0;} //   
}
else
{
tx2[1]=0x20;tx2[12]=0xc9; //  / 
bt4=0; //   1  
if (bt5==1) /// 
{
if (flv[i]==1) flv[i]=0; else flv[i]=1; eeprom_write(i+0x4d,flv[i]);
if (flv[0]==1 && i==0) ak1[4]=1; if (flv[1]==1 && i==1) ak2[3]=1; bt5=0;
}
}

tx2[2]=0xa8; tx2[3]=0x61; tx2[4]=0x79; tx2[5]=0xb7; tx2[6]=0x61; tx2[7]=0x20; tx2[10]=0x20;
bytetostr(fp[i],tx1); if (fp[i]<10) {tx2[8]=tx1[2]; tx2[9]=0x20;} else {tx2[8]=tx1[1]; tx2[9]=tx1[2];} //   
if (flv[i]==1) tx2[13]=0xd9; else tx2[13]=0xda; // / 
stroka(2); //  

if (bt1==1) {mnu=11; nms=3; bt1=0; bt2=0; bt3=0;} //    ""
}

void menu14() // ""
{
if (nms==3) {kp6=0; kp7=0;} //  SB4  SB5  
else        {kp6=1; kp7=1;} //  SB4  SB5 
but1(3); // 
tx2[0]=0x20; tx2[1]=0x20; tx2[2]=0x20;  tx2[3]=0x20;  tx2[4]=0x20;  tx2[5]=0x42;  tx2[6]=0x6f;  tx2[7]=0xb7;
tx2[8]=0xe3; tx2[9]=0x79; tx2[10]=0x78; tx2[11]=0x20; tx2[12]=0x20; tx2[13]=0x20; tx2[14]=0x20; tx2[15]=0x20;
stroka(1); //  

i=dt4[0]-1; //dt4[0]- 
if (nms==1) //    
{
tx2[0]=0xc9; tx2[1]=0xc9; tx2[2]=0xc9; tx2[6]=0x20; tx2[7]=0x20; tx2[8]=0x20; tx2[14]=0x20;
if (bt4==1) {vzr[i]++; if (vzr[i]>240) vzr[i]=0;   eeprom_write(i+0x4f,vzr[i]); if (i==0) mmv1=0; else mmv2=0; bt4=0;} //   
if (bt5==1) {vzr[i]--; if (vzr[i]>240) vzr[i]=240; eeprom_write(i+0x4f,vzr[i]); if (i==0) mmv1=0; else mmv2=0; bt5=0;} //   
}
if (nms==2) //    
{
tx2[0]=0x20; tx2[1]=0x20; tx2[2]=0x20; tx2[6]=0xc9; tx2[7]=0xc9; tx2[8]=0xc9; tx2[14]=0x20;
if (bt4==1) {vzp[i]++; if (vzp[i]>240) vzp[i]=0;   eeprom_write(i+0x51,vzp[i]); if (i==0) mmv1=0; else mmv2=0; bt4=0;} //   
if (bt5==1) {vzp[i]--; if (vzp[i]>240) vzp[i]=240; eeprom_write(i+0x51,vzp[i]); if (i==0) mmv1=0; else mmv2=0; bt5=0;} //   
}
if (nms==3) //  / 
{
tx2[0]=0x20; tx2[1]=0x20; tx2[2]=0x20; tx2[6]=0x20; tx2[7]=0x20; tx2[8]=0x20; tx2[14]=0xc9;
bt4=0; //   1  
if (bt5==1) {if (vzv[i]==1) vzv[i]=0; else vzv[i]=1; eeprom_write(i+0x53,vzv[i]); bt5=0;} /// 
}

tx2[4]=0xd9; tx2[5]=0x20; tx2[10]=0xda; tx2[11]=0x20; tx2[12]=0x20;
bytetostr(vzr[i],tx1); tx2[3]=tx1[2];
if (vzr[i]<10)              {tx2[0]=0x20;   tx2[1]=0x20;}
if (vzr[i]>9 && vzr[i]<100) {tx2[0]=0x20;   tx2[2]=tx1[1];}
if (vzr[i]>99)              {tx2[1]=tx1[0]; tx2[2]=tx1[1];}

bytetostr(vzp[i],tx1); tx2[9]=tx1[2];
if (vzp[i]<10)              {tx2[6]=0x20;   tx2[7]=0x20;}
if (vzp[i]>9 && vzp[i]<100) {tx2[6]=0x20;   tx2[8]=tx1[1];}
if (vzp[i]>99)              {tx2[7]=tx1[0]; tx2[8]=tx1[1];}
if (vzv[i]==1) tx2[15]=0xd9; else tx2[15]=0xda; // / 

stroka(2); //  

if (bt1==1) {mnu=11; nms=4; bt1=0; bt2=0; bt3=0;} //    ""
}

void menu15() // ""
{
if (nms==4 || nms==8) {kp6=0; kp7=0;} //  SB4  SB5  
else                  {kp6=1; kp7=1;} //  SB4  SB5 
but1(8); // 
if (dt4[0]==1) i=nms-1; else i=nms+7; //dt4[0]- 
if (bt4==1)
{
if (nms==1 || nms==5) {kr[i]++; if (kr[i]>23) kr[i]=0;} //kr[0],kr[4]-   1, kr[8],kr[12]-   2
if (nms==2 || nms==6) {kr[i]++; if (kr[i]>59) kr[i]=0;} //kr[1],kr[5]-   1, kr[9],kr[13]-   2
if (nms==3 || nms==7) {kr[i]++; if (kr[i]>9)  kr[i]=1;} //kr[2],kr[6]-   1, kr[10],kr[14]-   2
bt4=0;
eeprom_write(i+0x55,kr[i]);
}
if (bt5==1)
{
if (nms==1 || nms==5) {kr[i]--; if (kr[i]>23) kr[i]=23;} //kr[0],kr[4]-   1, kr[8],kr[12]-   2
if (nms==2 || nms==6) {kr[i]--; if (kr[i]>59) kr[i]=59;} //kr[1],kr[5]-   1, kr[9],kr[13]-   2
if (nms==3 || nms==7) {kr[i]--; if (kr[i]<1)  kr[i]=9;}  //kr[2],kr[6]-   1, kr[10],kr[14]-   2
if (nms==4 || nms==8) {if (kr[i]==1) kr[i]=0; else kr[i]=1;} //kr[3],kr[7]- /  1, kr[11],kr[15]- /  2
bt5=0;
eeprom_write(i+0x55,kr[i]);
}
tx2[0]=0x4b; tx2[1]=0x20; tx2[8]=0x20; tx2[9]=0x20; tx2[12]=0x20; tx2[13]=0x20;
if (nms==1) {tx2[2]=0xc9; tx2[5]=0x20; tx2[10]=0x20; tx2[14]=0x20;} //  1  
if (nms==2) {tx2[2]=0x20; tx2[5]=0xc9; tx2[10]=0x20; tx2[14]=0x20;} //  1  
if (nms==3) {tx2[2]=0x20; tx2[5]=0x20; tx2[10]=0xc9; tx2[14]=0x20;} //   
if (nms==4) {tx2[2]=0x20; tx2[5]=0x20; tx2[10]=0x20; tx2[14]=0xc9;} //  / 
if (nms>4)  {tx2[2]=0x20; tx2[5]=0x20; tx2[10]=0x20; tx2[14]=0x20;} //  2 

if (dt4[0]==1) i=0; else i=8;
bytetostr(kr[i],tx1);   if (kr[i]<10)   tx1[1]=0x30; tx2[3]=tx1[1]; tx2[4]=tx1[2]; //  ( )
bytetostr(kr[i+1],tx1); if (kr[i+1]<10) tx1[1]=0x30; tx2[6]=tx1[1]; tx2[7]=tx1[2]; //  ( )
bytetostr(kr[i+2],tx1); tx2[11]=tx1[2]; //  
if (kr[i+3]==1) tx2[15]=0xd9; else tx2[15]=0xda; // / 
stroka(1); //  

if (nms<5)  {tx2[2]=0x20; tx2[5]=0x20; tx2[10]=0x20; tx2[14]=0x20;} //  1 
if (nms==5) {tx2[2]=0xc9; tx2[5]=0x20; tx2[10]=0x20; tx2[14]=0x20;} //  2  
if (nms==6) {tx2[2]=0x20; tx2[5]=0xc9; tx2[10]=0x20; tx2[14]=0x20;} //  2  
if (nms==7) {tx2[2]=0x20; tx2[5]=0x20; tx2[10]=0xc9; tx2[14]=0x20;} //   
if (nms==8) {tx2[2]=0x20; tx2[5]=0x20; tx2[10]=0x20; tx2[14]=0xc9;} //  / 

if (dt4[0]==1) i=0; else i=8;
bytetostr(kr[i+4],tx1); if (kr[i+4]<10) tx1[1]=0x30; tx2[3]=tx1[1]; tx2[4]=tx1[2]; //  ( )
bytetostr(kr[i+5],tx1); if (kr[i+5]<10) tx1[1]=0x30; tx2[6]=tx1[1]; tx2[7]=tx1[2]; //  ( )
bytetostr(kr[i+6],tx1); tx2[11]=tx1[2]; //  
if (kr[i+7]==1) tx2[15]=0xd9; else tx2[15]=0xda; // / 
stroka(2); //  
if (bt1==1) {mnu=11; nms=5; bt1=0; bt2=0; bt3=0;} //    ""
}

void menu16() // ""
{
if (nms==2) {kp6=0; kp7=0;} //  SB4  SB5  
else        {kp6=1; kp7=1;} //  SB4  SB5 
but1(2); // 
tx2[0]=0x20; tx2[1]=0x20; tx2[2]=0x20;  tx2[3]=0x54;  tx2[4]=0x65;  tx2[5]=0x70;  tx2[6]=0xbc;  tx2[7]=0x6f;
tx2[8]=0x63; tx2[9]=0xbf; tx2[10]=0x61; tx2[11]=0xbf; tx2[12]=0x20; tx2[13]=0x20; tx2[14]=0x20; tx2[15]=0x20;
stroka(1); //  

i=dt4[0]-1; //dt4[0]- 
tx2[6]=0x00; tx2[7]=0x43; tx2[8]=0x20; tx2[9]=0x20;
if (nms==1)
{
tx2[3]=0xc9; tx2[10]=0x20; //   
if (bt4==1) {ts[i]++; if (ts[i]>30) ts[i]=15; eeprom_write(i+0x47,ts[i]); bt4=0;} //  
if (bt5==1) {ts[i]--; if (ts[i]<15) ts[i]=30; eeprom_write(i+0x47,ts[i]); bt5=0;} //  
}
else
{
tx2[3]=0x20; tx2[10]=0xc9; //  / 
bt4=0; //   1  
if (bt5==1) {if (tsv[i]==1) tsv[i]=0; else tsv[i]=1; eeprom_write(i+0x49,tsv[i]); bt5=0;} ///  
}

bytetostr(ts[i],tx1); tx2[4]=tx1[1]; tx2[5]=tx1[2]; //  
if (tsv[i]==1) tx2[11]=0xd9; else tx2[11]=0xda; // / 
stroka(2); //  

if (bt1==1) {mnu=11; nms=6; bt1=0; bt2=0; bt3=0;} //    ""
}


void menu17() //      
{
kp6=0; kp7=0; //  SB4  SB5  
but1(4); // 
tx2[0]=0x20; tx2[1]=0x20; tx2[2]=0x20; tx2[11]=0x20; tx2[13]=0x20; tx2[14]=0x20; tx2[15]=0x20;
tx2[3]=0x41; tx2[4]=0x03; tx2[5]=0x02; tx2[6]=0x61;  tx2[7]=0x70;  tx2[8]=0xb8;  tx2[9]=0x79; tx2[10]=0xbc;
if (nms==1 || nms==2) tx2[12]=0x31; else tx2[12]=0x32;
stroka(1); //  

if (nms==1 || nms==3) 
{tx2[0]=0x42; tx2[1]=0x6f; tx2[2]=0xe3; tx2[3]=0x61; tx2[4]=0x20; tx2[5]=0x20;}
else
{tx2[0]=0xaa; tx2[1]=0xb8; tx2[2]=0xbb; tx2[3]=0x04; tx2[4]=0xbf; tx2[5]=0x70;}
tx2[6]=0x20; tx2[7]=0x20; tx2[10]=0x2e; tx2[13]=0x2e;

bt4=0; //   1  

if (nms==1) //    ( 1)
{
if (bt5==1) {chv[0]=chd; msv[0]=msd; gdv[0]=gdd; eeprom_write(0x1b,chv[0]); eeprom_write(0x1d,msv[0]); eeprom_write(0x1f,gdv[0]); bt5=0;} // 
dt4[1]=chv[0]; dt4[2]=msv[0]; dt4[3]=gdv[0];
}
if (nms==2) //    ( 1)
{
if (bt5==1) {chf[0]=chd; msf[0]=msd; gdf[0]=gdd; eeprom_write(0x21,chf[0]); eeprom_write(0x23,msf[0]); eeprom_write(0x25,gdf[0]); bt5=0;} // 
dt4[1]=chf[0]; dt4[2]=msf[0]; dt4[3]=gdf[0];
}
if (nms==3) //    ( 2)
{
if (bt5==1) {chv[1]=chd; msv[1]=msd; gdv[1]=gdd; eeprom_write(0x1c,chv[1]); eeprom_write(0x1e,msv[1]); eeprom_write(0x20,gdv[1]); bt5=0;} // 
dt4[1]=chv[1]; dt4[2]=msv[1]; dt4[3]=gdv[1];
}
if (nms==4) //    ( 2)
{
if (bt5==1) {chf[1]=chd; msf[1]=msd; gdf[1]=gdd; eeprom_write(0x22,chf[1]); eeprom_write(0x24,msf[1]); eeprom_write(0x26,gdf[1]); bt5=0;} // 
dt4[1]=chf[1]; dt4[2]=msf[1]; dt4[3]=gdf[1];
}
// dt4[1], dt4[2], dt4[3]     
bytetostr(dt4[1],tx1); if (dt4[1]<10) tx1[1]=0x30; tx2[8]=tx1[1];  tx2[9]=tx1[2];  //  
bytetostr(dt4[2],tx1); if (dt4[2]<10) tx1[1]=0x30; tx2[11]=tx1[1]; tx2[12]=tx1[2]; //  
bytetostr(dt4[3],tx1); if (dt4[3]<10) tx1[1]=0x30; tx2[14]=tx1[1]; tx2[15]=tx1[2]; //  
stroka(2); //  
if (bt1==1) {mnu=0; bt1=0; bt2=0; bt3=0; in1=1;} //    
}

void menu18() // " "
{
kp6=0; kp7=0; //  SB4  SB5  
but1(2); // 
if (nms==1) tx2[0]=0xc9; else tx2[0]=0x20; //   " 1"
tx2[1]=0x41; tx2[2]=0x03;  tx2[3]=0x02;  tx2[4]=0x61;  tx2[5]=0x70;  tx2[6]=0xb8;  tx2[7]=0x79; tx2[8]=0xbc;
tx2[9]=0x20; tx2[10]=0x31; tx2[11]=0x20; tx2[12]=0x20; tx2[13]=0x20; tx2[14]=0x20; tx2[15]=0x20;
stroka(1); //  
if (nms==2) tx2[0]=0xc9; else tx2[0]=0x20; //   " 2"
tx2[10]=0x32;
stroka(2); //  
if (bt1==1) {mnu=0; bt1=0; bt2=0; bt3=0; in1=1;} //    
bt4=0; //   1  
if (bt5==1)
{
if (nms==1) {mnu=19; dt4[0]=1;} //   " 1" dt4[0]- 
if (nms==2) {mnu=19; dt4[0]=2;} //    " 2"
nms=1; bt2=0; bt3=0; bt5=0;
}
}

void menu19() // " " -  
{
kp6=0; kp7=0; //  SB4  SB5  
but1(5); // 
if (bt5==1)
{
if (nms==1) // 1
{
if (dt4[0]==1) {if (ak1[6]==1) ak1[6]=0; else ak1[6]=1;}
if (dt4[0]==2) {if (ak2[1]==1) ak2[1]=0; else ak2[1]=1;}
}
if (nms==2) // 2
{
if (dt4[0]==1) {if (ak1[5]==1) ak1[5]=0; else ak1[5]=1;}
if (dt4[0]==2) {if (ak2[2]==1) ak2[2]=0; else ak2[2]=1;}
}
if (nms==3) //
{
if (flv[0]==1) {if (dt4[0]==1) {if (ak1[4]==1) {ak1[4]=0; f1=1;} else {ak1[4]=1; f1=0;}}} //f1=1-       1
if (flv[1]==1) {if (dt4[0]==2) {if (ak2[3]==1) {ak2[3]=0; f2=1;} else {ak2[3]=1; f2=0;}}} //f2=1-       2
}
if (nms==4) //
{
if (v11==1) {if (dt4[0]==1) {if (ak1[3]==1) ak1[3]=0; else ak1[3]=1; mmv1=0;}}
if (v21==1) {if (dt4[0]==2) {if (ak2[4]==1) ak2[4]=0; else ak2[4]=1; mmv2=0;}}
}
if (nms==5) //
{
if (kr[3]==1  || kr[7]==1)  {if (dt4[0]==1) {if (ak1[2]==1) ak1[2]=0; else {ak1[2]=1; k1=1;}}}
if (kr[11]==1 || kr[15]==1) {if (dt4[0]==2) {if (ak2[5]==1) ak2[5]=0; else {ak2[5]=1; k2=1;}}}
}
bt2=0; bt3=0; bt5=0;
}
if (nms==1 || nms==2) //  " 1"  " 2"
{
if (nms==1) tx2[0]=0xc9; else tx2[0]=0x20; //   " 1"
tx2[1]=0x54; tx2[2]=0x61;  tx2[3]=0x01;  tx2[4]=0xbc;  tx2[5]=0x65;  tx2[6]=0x70;  tx2[7]=0x20; tx2[8]=0x31;
tx2[9]=0x20; tx2[10]=0x20; tx2[11]=0x20; tx2[12]=0x20; tx2[13]=0x20; tx2[14]=0x20;
if (dt4[0]==1) {if (ak1[6]==1) tx2[15]=0xd9; else tx2[15]=0xda;}
if (dt4[0]==2) {if (ak2[1]==1) tx2[15]=0xd9; else tx2[15]=0xda;}
stroka(1); //  
if (nms==2) tx2[0]=0xc9; else tx2[0]=0x20; //   " 2"
tx2[8]=0x32;
if (dt4[0]==1) {if (ak1[5]==1) tx2[15]=0xd9; else tx2[15]=0xda;}
if (dt4[0]==2) {if (ak2[2]==1) tx2[15]=0xd9; else tx2[15]=0xda;}
stroka(2); //  
}
if (nms==3 || nms==4) //  ""  ""
{
if (nms==3) tx2[0]=0xc9; else tx2[0]=0x20; //   ""
tx2[1]=0xaa; tx2[2]=0xb8;  tx2[3]=0xbb;  tx2[4]=0x04;  tx2[5]=0xbf;  tx2[6]=0x70;  tx2[7]=0x20; tx2[8]=0x20;
tx2[9]=0x20; tx2[10]=0x20; tx2[11]=0x20; tx2[12]=0x20; tx2[13]=0x20; tx2[14]=0x20;
if (dt4[0]==1) {if (ak1[4]==1) tx2[15]=0xd9; else tx2[15]=0xda;}
if (dt4[0]==2) {if (ak2[3]==1) tx2[15]=0xd9; else tx2[15]=0xda;}
stroka(1); //  
if (nms==4) tx2[0]=0xc9; else tx2[0]=0x20; //   ""
tx2[1]=0x42; tx2[2]=0x6f; tx2[3]=0xb7; tx2[4]=0xe3; tx2[5]=0x79; tx2[6]=0x78;
if (dt4[0]==1) {if (ak1[3]==1) tx2[15]=0xd9; else tx2[15]=0xda;}
if (dt4[0]==2) {if (ak2[4]==1) tx2[15]=0xd9; else tx2[15]=0xda;}
stroka(2); //  
}
if (nms==5) //  ""
{
tx2[0]=0xc9; tx2[1]=0x4b; tx2[2]=0x6f;  tx2[3]=0x70;  tx2[4]=0xbc;  tx2[5]=0x79;  tx2[6]=0xc1;  tx2[7]=0x03;
tx2[8]=0x61; tx2[9]=0x20; tx2[10]=0x20; tx2[11]=0x20; tx2[12]=0x20; tx2[13]=0x20; tx2[14]=0x20;
if (dt4[0]==1) {if (ak1[2]==1) tx2[15]=0xd9; else tx2[15]=0xda;}
if (dt4[0]==2) {if (ak2[5]==1) tx2[15]=0xd9; else tx2[15]=0xda;}
stroka(1); //  
for (i=0; i<16; i++) tx2[i]=0x20;
stroka(2); //  
}
if (bt1==1) {mnu=18; if (dt4[0]==1) nms=1; else nms=2; bt1=0; bt2=0; bt3=0;} //    " 1   2"
bt4=0; //   1  
}

void rele() /// 
{
for (i=0; i<2; i++) /// 
{
for (ak1[0]=0; ak1[0]<13; ak1[0]=ak1[0]+4)
{
if (ak1[0]==0)  dt4[7]=ak1[6]; //1  1 
if (ak1[0]==4)  dt4[7]=ak1[5]; //2  1 
if (ak1[0]==8)  dt4[7]=ak2[1]; //1  2 
if (ak1[0]==12) dt4[7]=ak2[2]; //2  2 
dt4[3]=hh[i*2+ak1[0]]; dt4[4]=hh[i*2+1+ak1[0]]; dt4[5]=mm[i*2+ak1[0]]; dt4[6]=mm[i*2+1+ak1[0]];
if (dt4[3]!=dt4[4] || dt4[5]!=dt4[6]) //    /
{
if (dt4[3]==hht && dt4[5]==mmt && sst==0) dt4[7]=1; //
if (dt4[4]==hht && dt4[6]==mmt && sst==0) dt4[7]=0; //
if (ak1[0]==0)  ak1[6]=dt4[7]; //1  1 
if (ak1[0]==4)  ak1[5]=dt4[7]; //2  1 
if (ak1[0]==8)  ak2[1]=dt4[7]; //1  2 
if (ak1[0]==12) ak2[2]=dt4[7]; //2  2 
}
}
}
ak1[0]=0;


if (flv[0]==1) //  1 
{
if (f1==1) {flm[0]=mmt+fp[0]; if (flm[0]>59) flm[0]=flm[0]-60; fls[0]=sst; f1=0;}
if (flm[0]==mmt && fls[0]==sst) ak1[4]=1;
} else ak1[4]=0;

if (flv[1]==1) //  2 
{
if (f2==1) {flm[1]=mmt+fp[1]; if (flm[1]>59) flm[1]=flm[1]-60; fls[1]=sst; f2=0;}
if (flm[1]==mmt && fls[1]==sst) ak2[3]=1;
} else ak2[3]=0;


if (kr[3]==1 || kr[7]==1) //  1 
{
if (kr[0]==hht && kr[1]==mmt && sst==0 && kr[3]==1) {ak1[2]=1; ak1[4]=0; f1=1;} //1 
if (kr[0]==hht && kr[1]==mmt && sst==kr[2])          ak1[2]=0; //1 

if (kr[4]==hht && kr[5]==mmt && sst==0 && kr[7]==1) {ak1[2]=1; ak1[4]=0; f1=1;} //2 
if (kr[4]==hht && kr[5]==mmt && sst==kr[6])          ak1[2]=0; //2 

if (k1==1) {ssk1=sst+kr[2];  if (ssk1>59) ssk1=ssk1-60; k1=0; ak1[4]=0; f1=1;}
if (ak1[2]==1 && ssk1==sst) {ak1[2]=0; ssk1=30;} //   1   
} else ak1[2]=0;

if (kr[11]==1 || kr[15]==1) //  2 
{
if (kr[8]==hht &&  kr[9]==mmt &&  sst==0 && kr[11]==1) {ak2[5]=1; ak2[3]=0; f2=1;} //1 
if (kr[8]==hht &&  kr[9]==mmt &&  sst==kr[10])          ak2[5]=0; //1 

if (kr[12]==hht && kr[13]==mmt && sst==0 && kr[15]==1) {ak2[5]=1; ak2[3]=0; f2=1;} //2 
if (kr[12]==hht && kr[13]==mmt && sst==kr[14])          ak2[5]=0; //2 

if (k2==1) {ssk2=sst+kr[10]; if (ssk2>59) ssk2=ssk2-60; k2=0; ak2[3]=0; f2=1;}
if (ak2[5]==1 && ssk2==sst) {ak2[5]=0; ssk2=30;} //   2   
} else ak2[5]=0;


if ((grv==0) || (grv==1 && hht>ngr-1 && hht<vgr)) // 
{
if (tsv[0]==1) {if (tc[0]<ts[0]) ak1[1]=1; if (tc[0]>ts[0]) ak1[1]=0;} else ak1[1]=0; //  1 
if (tsv[1]==1) {if (tc[1]<ts[1]) ak2[6]=1; if (tc[1]>ts[1]) ak2[6]=0;} else ak2[6]=0; //  2 

if (vzv[0]==1) //  1 
{
if (vzr[0]==0 && vzp[0]==0) {v11=1; v12=1;} //    ,   
if (vzr[0]!=0 && vzp[0]==0) {ak1[3]=1; v11=0; v12=1;} //  ,   
if (vzr[0]==0 && vzp[0]!=0) {ak1[3]=0; v11=0; v12=1;} //  ,   
if (vzr[0]!=0 && vzp[0]!=0) // ,  
{
v11=1;
if (v12==1) {ak1[3]=1; v12=0;} //      
if (sst==59 && v13==1) {mmv1++; v13=0;} if (sst==0) v13=1; //   
if (mmv1==vzp[0] && ak1[3]==0 && sst==0) {mmv1=0; ak1[3]=1;} //
if (mmv1==vzr[0] && ak1[3]==1 && sst==0) {mmv1=0; ak1[3]=0;} //
}
} else {ak1[3]=0; v11=0; v12=1; mmv1=0;}

if (vzv[1]==1) //  2 
{
if (vzr[1]==0 && vzp[1]==0) {v21=1; v22=1;} //    ,   
if (vzr[1]!=0 && vzp[1]==0) {ak2[4]=1; v21=0; v22=1;} //  ,   
if (vzr[1]==0 && vzp[1]!=0) {ak2[4]=0; v21=0; v22=1;} //  ,   
if (vzr[1]!=0 && vzp[1]!=0) // ,  
{
v21=1;
if (v22==1) {ak2[4]=1; v22=0;} //      
if (sst==59 && v23==1) {mmv2++; v23=0;} if (sst==0) v23=1; //   
if (mmv2==vzp[1] && ak2[4]==0 && sst==0) {mmv2=0; ak2[4]=1;} //
if (mmv2==vzr[1] && ak2[4]==1 && sst==0) {mmv2=0; ak2[4]=0;} //
}
} else {ak2[4]=0; v21=0; v22=1; mmv2=0;}

}
else
{
if (tsv[0]==1) {if (tc[0]<ts[0]-2) ak1[1]=1; if (tc[0]>ts[0]-2) ak1[1]=0;} else ak1[1]=0; //  1 
if (tsv[1]==1) {if (tc[1]<ts[1]-2) ak2[6]=1; if (tc[1]>ts[1]-2) ak2[6]=0;} else ak2[6]=0; //  2 
ak1[3]=0; v11=0; v12=1; mmv1=0; ak2[4]=0; v21=0; v22=1; mmv2=0;
}

for (i=0; i<8; i++) {porta.b5=ak1[7-i]; portc.b7=ak2[7-i]; portb.b1=~portb.b1; portb.b1=0;} //    
portc.b0=~portc.b0; portc.b0=0; //       
}

void nagr() //     / 
{
//z1-     t-    z2-   
for (i=0; i<2; i++)
{
for (ak1[0]=0; ak1[0]<13; ak1[0]=ak1[0]+4)
{
dt4[0]=hh[i*2+ak1[0]]; dt4[1]=hh[i*2+1+ak1[0]]; dt4[2]=mm[i*2+ak1[0]]; dt4[3]=mm[i*2+1+ak1[0]];
if (dt4[0]!=dt4[1] || dt4[2]!=dt4[3]) //    /
{
t=hht*60+mmt; z1=dt4[0]*60+dt4[2]; z2=dt4[1]*60+dt4[3]; if (z2<z1) {if (t<z1) t=t+1440; z2=z2+1440;}
if (t>=z1 && t<z2) //  
{
if (ak1[0]==0)  ak1[6]=1; //1  1 
if (ak1[0]==4)  ak1[5]=1; //2  1 
if (ak1[0]==8)  ak2[1]=1; //1  2 
if (ak1[0]==12) ak2[2]=1; //2  2 
}
}
}
}
ng=0;
}

void main() // 
{
osccon=0x70; //   8 
c1on_bit=0; c2on_bit=0; // 
ansela=0x00; anselb=0x00; // A,B-
porta=0x00; trisa=0x11;
portb=0x00; trisb=0xf9;
portc=0x42; trisc=0x00;
portc.b0=~portc.b0; portc.b0=0; portb.b2=1; //  
option_reg=0x06; wpub=0xc8; wpue=0xff; //    RB3, RB6, RB7, RE3
tmr0=0; intcon=0x90; //    INT(RB0)
soft_i2c_init(); // i2c (DS1307)
lcd_init(); // 
lcd_cmd(_lcd_cursor_off); // 
znak(); //    
eepr(); //   eeprom  
mnu=0; //    
bt1=0;bt2=0;bt3=0;bt4=0;bt5=0;kp1=0;kp2=0;kp3=0;kp4=0;kp5=0;kp6=0;kp7=0;f1=0;f2=0;ng=1;
pdv=1;v11=0;v12=1;v13=1;v21=0;v22=1;v23=1;k1=0;k2=0;ssk1=30;ssk2=30;in1=1;pog=0;ssp=0;
mmv1=0;mmv2=0;nd[0]=0;nd[1]=0;nd[2]=0;pds=100;i1=0;i2=0;ir0=1;ir1=0;ir2=0;pr=0;j=0;
ak1[6]=0;ak1[5]=0;ak1[4]=1;ak1[3]=1;ak1[2]=0;ak1[1]=0;ak2[1]=0;ak2[2]=0;ak2[3]=1;ak2[4]=1;ak2[5]=0;ak2[6]=0;
do //    
{
delay_ms(50); ssp++; // 0,1 
pr=~pr;
if (pr==0) {ir0=1; i1=0; i2=0; option_reg=0x06; ir1=0;} //  0,1     ,     
if (ssp>4)
{
ssp=0;
soft_i2c_start();     //    DS1307
soft_i2c_write(0xd0); //   
soft_i2c_write(0);    //    
soft_i2c_start();     //  
soft_i2c_write(0xd1); //   
sst=soft_i2c_read(1); //0  - 
mmt=soft_i2c_read(1); //1  - 
hht=soft_i2c_read(1); //2  - 
  i=soft_i2c_read(1);
chd=soft_i2c_read(1); //4  -  
msd=soft_i2c_read(1); //5  - 
gdd=soft_i2c_read(0); //6  - 
soft_i2c_stop();      //    DS1307
sst=Bcd2Dec(sst); mmt=Bcd2Dec(mmt); hht=Bcd2Dec(hht);
chd=Bcd2Dec(chd); msd=Bcd2Dec(msd); gdd=Bcd2Dec(gdd); //Bcd2Dec -     

if (ng==1) nagr(); //     / 

if (hht!=0) pog=0; //pog-    
if (pog==0 && hht==0 && mmt==0 && sst==25) //  ()    (0:00:25)
{
sst=sst+ot-sp; //  / 
sst=Dec2Bcd(sst);
soft_i2c_start();     //    DS1307
soft_i2c_write(0xd0); //   
soft_i2c_write(0);    //    
soft_i2c_write(sst);  // 
soft_i2c_stop();      // 
sst=Bcd2Dec(sst);
pog=1;
}

if (mnu==0)  menu0();  //  
if (mnu==1)  menu1();  // ""
if (mnu==2)  menu2();  // ""
if (mnu==3)  menu3();  // "()"
if (mnu==4)  menu4();  // ""
if (mnu==5)  menu5();  // " "
if (mnu==6)  menu6();  // ""
if (mnu==7)  menu7();  // ""
if (mnu==8)  menu8();  // " "
if (mnu==9)  menu9();  // ""
if (mnu==10) menu10(); // " "
if (mnu==11) menu11(); // " 1   2"
if (mnu==12) menu12(); // " 1   2"
if (mnu==13) menu13(); // ""
if (mnu==14) menu14(); // ""
if (mnu==15) menu15(); // ""
if (mnu==16) menu16(); // ""
if (mnu==17) menu17(); //      
if (mnu==18) menu18(); // " "
if (mnu==19) menu19(); // " " -  

temp(0); //  ( 1)
temp(1); //  ( 2)
temp(2); //  ( 3)
rele();  // 

if (pdv==1)   {if (pd1==1) {portc.b6=0; pds=sst+pd2; if (pds>59) pds=pds-60; pdv=0;} else {portc.b6=1; pds=100; pdv=0;}} //  
if (pds==sst) {portc.b6=1; pds=100;} //  
}
}
while(1);
}